/*
 * Raima Database Manager
 *
 * Copyright (C) 2016 Raims Inc.,  All rights reserved.
 *
 * Use of this software, whether in source code format, or in executable,
 * binary object code form, is governed by the Raima LICENSE which
 * is fully described in the LICENSE.TXT file, included within this
 * distribution of files.
 */

/** \file psptypes-vxworks.h
 *  \brief Header for the Platform Support Package - Platform dependent types for VxWorks
 */

#ifndef RDM_DOXYGEN
#ifndef PSPTYPES_VXWORKS_H
#define PSPTYPES_VXWORKS_H

#include <vxWorks.h>

#if !defined(__INCstdinth)
#if defined(RDM_32BIT)
typedef int32_t intptr_t;
typedef uint32_t uintptr_t;
#else /* defined(RDM_64BIT) */
typedef int64_t intptr_t;
typedef uint64_t uintptr_t;
#endif
#endif
typedef int64_t intmax_t;
typedef uint64_t uintmax_t;

#if defined(RDM_64BIT)
#define RDM_64BIT_CODE RDM_T ("l")
#define RDM_64BIT_CODE_A "l"
#else
#define RDM_64BIT_CODE RDM_T ("ll")
#define RDM_64BIT_CODE_A "ll"
#endif

#define RDM_STARTUP_VXWORKS(name,main_entry)                            \
    int32_t name##_main (int32_t argc, const char *const *argv);        \
    int32_t main_entry (                                                \
        const char *a1, const char *a2, const char *a3,                 \
        const char *a4, const char *a5, const char *a6,                 \
        const char *a7, const char *a8, const char *a9,                 \
        const char *a10)                                                \
    {                                                                   \
        int32_t status;                                                 \
        int32_t argc = 0;                                               \
        const char * const argv[] = {#name, a1, a2, a3, a4, a5,         \
                                     a6, a7, a8, a9, a10, NULL};        \
        while (argv[++argc])                                            \
        {                                                               \
        }                                                               \
        RDM_STARTUP_HOOK                                                \
        status = psp_threadMain (name##_main, argc, argv);              \
        RDM_SHUTDOWN_HOOK                                               \
        return status;                                                  \
    }
#define RDM_STARTUP_EXAMPLE(name) RDM_STARTUP_VXWORKS (name, name)
#define RDM_STARTUP_TEST(name) RDM_STARTUP_VXWORKS (name, test)
#endif
#endif
