/*
 * Raima Database Manager
 *
 * Copyright (C) 2016 Raims Inc.,  All rights reserved.
 *
 * Use of this software, whether in source code format, or in executable,
 * binary object code form, is governed by the Raima LICENSE which
 * is fully described in the LICENSE.TXT file, included within this
 * distribution of files.
 */

/** \file rdmtfstypes.h
 *  \brief Header for the Transactional File Server (TFS) types
 */

#if !defined(RDMTFSTYPES_H_INCLUDED_)
#define RDMTFSTYPES_H_INCLUDED_

#include "psptypes.h"

typedef struct RDM_TFS_S *RDM_TFS; /**< \brief RDM TFS Handle */

/** tfs types */
typedef enum
{
    TFS_TYPE_EMBED, /**< The built in in-memory TFS, embedded tfs, or TFS server */
    TFS_TYPE_CLIENT, /**< The TFS client that only has the capability to connect to a remote TFS */
    TFS_TYPE_HYBRID, /**< The hybrid TFS that has all capabilities */
    TFS_TYPE_DEFAULT /**< The default TFS, which depend on which TFS your
                        application is linked with */
} TFS_TYPE;

#define STR_TFS_TYPE_EMBED                                                     \
    "EMBED" /**< The string representation for the embedded TFS */
#define STR_TFS_TYPE_SERVER                                                    \
    "SERVER" /**< The string representation for an alias of embedded TFS */
#define STR_TFS_TYPE_CLIENT                                                    \
    "CLIENT" /**< The string representation for the TFS client */
#define STR_TFS_TYPE_REMOTE                                                    \
    "REMOTE" /**< The string representation for an alias of TFS client */
#define STR_TFS_TYPE_HYBRID                                                    \
    "HYBRID" /**< The string representation for the hybrid TFS */
#define STR_TFS_TYPE_DEFAULT                                                   \
    "DEFAULT" /**< The string representation for the default TFS */

#endif /* RDMTFSTYPES_H_INCLUDED_ */
